#include "RPar.h"

extern PegBitmap gbdibrparBitmap;

RPar::RPar(PegRect rect, CPMainFrame* frame):CPModuleWindow(rect,0,0,frame)
{
init();
}

int RPar::init()
{   
   	const WORD wStyle = FF_NONE|TJ_LEFT|AF_TRANSPARENT| TT_COPY;
	const SIGNED margin = 10;
	const SIGNED width=mClient.Width()-2*margin;
    
   	PEGCHAR* chrohm = "\xEC\x7E"; 

    PegRect rectangle;
 
 	PegPrompt* label = new PegPrompt(margin, 60, width, "Req("+CPString(chrohm)+"):",0,wStyle);
	Req = new CPPegString(margin+50,60,width - 70,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	AddR(Req);
	AddR(label);

	PegPrompt* label1 = new PegPrompt(margin, 80, width, "Calcular:",0,wStyle);
	AddR(label1);
    	
     //rectangle.Set(MAINFRAME_LEFT, MAINFRAME_TOP, MAINFRAME_RIGHT, MAINFRAME_BOTTOM);
    rectangle.Set(60, 80, 85, 95);
   	PegTextButton* b1 = new PegTextButton(rectangle, "E12", BOTO1, AF_ENABLED|TJ_CENTER);
	AddR(b1);

    rectangle.Set(90, 80, 115, 95);
   	PegTextButton* b2 = new PegTextButton(rectangle, "E24", BOTO2, AF_ENABLED|TJ_CENTER);
	AddR(b2);

    rectangle.Set(120, 80, 145, 95);
   	PegTextButton* b3 = new PegTextButton(rectangle, "E48", BOTO3, AF_ENABLED|TJ_CENTER);
	AddR(b3);
	
    rectangle.Set(MAINFRAME_LEFT, MAINFRAME_TOP, MAINFRAME_RIGHT, MAINFRAME_TOP+60);
 	PegBitmapButton * imatge = new PegBitmapButton(rectangle,&gbdibrparBitmap,0,AF_TRANSPARENT,TYPE_PROMPT,FALSE);
 	AddR(imatge); 

    PegRect ListRect;
 	ListRect.Set(10, 100, MAINFRAME_RIGHT-10, 185); 
    pList = new PegVertList(ListRect,ID_VERTLIST);
    
    pList->SetScrollMode(WSM_AUTOVSCROLL); 
      
    AddR(pList);
      	
 	e48[0] = 100; e48[1] = 105; e48[2] = 110; e48[3] = 115; e48[4] = 121; e48[5] = 127; e48[6] = 133;
    e48[7] = 140; e48[8] = 147; e48[9] = 154; e48[10] = 162; e48[11] = 169; e48[12] = 178; e48[13] = 187; e48[14] = 196;
	e48[15] = 205; e48[16] = 215; e48[17] = 226; e48[18] = 237; e48[19] = 249; e48[20] = 261; e48[21] = 274; e48[22] = 287;
	e48[23] = 301; e48[24] = 316; e48[25] = 332; e48[26] = 348; e48[27] = 365; e48[28] = 383;
	e48[29] = 402; e48[30] = 422; e48[31] = 442; e48[32] = 464; e48[33] = 487;
	e48[34] = 511; e48[35] = 536; e48[36] = 562; e48[37] = 590;
	e48[38] = 619; e48[39] = 649; e48[40] = 681;
	e48[41] = 715; e48[42] = 750; e48[43] = 787;
	e48[44] = 825; e48[45] = 866;
	e48[46] = 909; e48[47] = 953;
	
	e24[0] = 100; e24[1] = 110; e24[2] = 120; e24[3] = 130;
    e24[4] = 150; e24[5] = 160; e24[6] = 180;
    e24[7] = 200; e24[8] = 220; e24[9] = 240; e24[10] = 270;
	e24[11] = 300; e24[12] = 330; e24[13] = 360; e24[14] = 390;
	e24[15] = 430; e24[16] = 470;
	e24[17] = 510; e24[18] = 560;
	e24[19] = 629; e24[20] = 680;
	e24[21] = 750;
	e24[22] = 820;
	e24[23] = 910;

	e12[0] = 100; e12[1] = 120; e12[2] = 150; e12[3] = 180; e12[4] = 220;
    e12[5] = 270; e12[6] = 330; e12[7] = 390; e12[8] = 470; e12[9] = 560;
    e12[10] = 680; e12[11] = 820;
    
	return 0;
}

void RPar::Draw()
{
	BeginDraw();
	Invalidate(mClient);
	DrawFrame();
	DrawChildren();
	EndDraw();
}

SIGNED RPar::Message(const PegMessage &Mesg)
{
	switch(Mesg.wType)
	{
		case SIGNAL(BOTO1, PSF_CLICKED):
		{
             Calcula(e12,12);
		}
		break;
		case SIGNAL(BOTO2, PSF_CLICKED):
		{
             Calcula(e24,24);
		}
		break;
		case SIGNAL(BOTO3, PSF_CLICKED):
		{
             Calcula(e48,48);
		}
		break;
		
		default:
		return CPModuleWindow::Message(Mesg);
	}
	return 0;
}

WORD RPar::Dialog(char* title, char* message)
{
	PegRect rr = GetMainFrame()->TopAppRectangle();
	rr.wBottom -= 30;
	rr.wRight -= 10;
	rr.wTop += 10;
	rr.wLeft += 10;
	PegMessageWindow *msg = new PegMessageWindow(rr, title, message, MW_OK, 0,0,0);
	return msg->Execute();
}

void RPar::Calcula(int* vals,int nvals)
{
    int i,j,k;
    OBCD aux, aux2, dif, bestdif, bestRpar, objective;
   	PEGCHAR* chrohm = "\xEC\x7E"; 
    unsigned short expon;
    
    pList->Clear();
    
    objective = CPExpression(Req->DataGet());
    
    for(i=0;i<nvals;i++)
    {
       Cal_setn_OBC(0,&bestRpar);
       Cal_setinfp_OBC(&bestdif);
       Cal_shortto_OBC(vals[i],&aux);
       expon = objective.obcd1.exponential;
       aux.obcd1.exponential = expon;
       if(aux==objective)
       {
           Cal_setinfp_OBC(&bestRpar);
	       bestdif = objective;
       	   Cal_sub_OBC(&bestdif,&aux);
           Cal_abs_OBC(&bestdif);
       }
       else if(aux < objective)
       {
           aux.obcd1.exponential +=1 ;
       }    
           
       for(k=0;k<2;k++)
	   {
		   expon += k;
		   for(j=0;j<nvals;j++)
		   {
			   Cal_shortto_OBC(vals[j],&aux2);
			   aux2.obcd1.exponential = expon;
			   aux2 = CalculaPar(aux,aux2);
			   dif = objective;
			   Cal_sub_OBC(&dif,&aux2);
			   Cal_abs_OBC(&dif);
			   if(dif < bestdif)
			   {
				   bestdif = dif;
				   Cal_shortto_OBC(vals[j],&bestRpar);
				   bestRpar.obcd1.exponential = expon;
			   }
		   }
	   }
             

       Cal_div_OBC(&bestdif,&objective);
       ExecuteToOBCD("100",aux2);
       Cal_mul_OBC(&bestdif,&aux2);
       Cal_cintx_OBC(&bestdif,2);
       pList->AddToEnd(new PegPrompt(0, 0, CPString(bestdif)+"%: "+CPString(aux)+CPString(chrohm)+"//"+CPString(bestRpar)+CPString(chrohm), 10, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY));  
    }    
    
    Draw();
}   

OBCD RPar::CalculaPar(OBCD rx, OBCD ry)
{
    OBCD aux;
    aux = rx;
    Cal_add_OBC(&aux,&ry);
    Cal_inverse_OBC(&aux);
    Cal_mul_OBC(&aux,&ry);
    Cal_mul_OBC(&aux,&rx);
    
    return aux;
}
    
extern "C" char *ExtensionGetLang(ID_MESSAGE MessageNo)
{
return "";
}
